/* %W% %D% */

#include <stdio.h>
#include <signal.h>
#ifdef SUN4
#include <floatingpoint.h>
#endif
#include "constdef.h"
#include "defvar.h"


setup()
{
  WORD *fp=lstack;
  WORD intern(),internsym(),alvector(),alspec(),udferr(),utilisp_f(),alsym();

  nil=alsym("nil",3,fp);
  obvect=alvector(0x80,fp);
  uderr=alspec();
  spectop(uderr)=udferr;
  obvector=alsym("obvector",8,fp);
  value(obvector)=obvect;
  plist(nil)=nil;
  value(nil)=nil;
  definition(nil)=uderr;
  internsym(obvector);
  init_var();
  internsym(nil);
  init_subr();
  init_spec();
  init_deffunc();
  /* read lispsys.l */
  initsig();
  init_rtable();
  readrc(LISPSYS,lstack);
}
readrc(filename,fp)
char *filename;
WORD *fp;
{
  WORD defeof,stream,stream_f(),alstring(),read_f(),defeof_f();
  WORD alcode(),inopen_f();

  defeof=alcode(0,fp);
  *(FP *)(defeof+CODETOP)=defeof_f;
  value(err_end_of_file)=defeof;
  l(0)=alstring(filename,fp);
  l(1)=stream_f(1,fp-1);
  inopen_f(1,fp-2);
  for(;;){
    eval(read_f(1,fp-2),fp-2);
  }
}

WORD defeof_f(na,fp)
WORD *fp;
{
  extern int bstacksize,cstacksize;
  jmp_buf env,*tmpenv0,*tmpenv1;
  WORD *tmplstack=lstack,*tmpbstack=bstack,val,rval,body;
  WORD *tmpcstack=cstack,read_f();

  if(setjmp(env)){
    while(bstack<tmpbstack){
      val=popb();
      value(popb())=val;
    }
    cstack=tmpcstack;
  }
  else{
    PUTS(stringcodes(topprompt),sostream);
    FLUSH(sostream);
  }
  if((--estack)<estacktop){
    printf("estack overflow\n");
    exit(1);
  }
  estack->envtag=TOPENV;
  estack->envobj=nil;
  estack->envbuf=(jmp_buf *)env;
  value(standard_input)=value(terminal_input);
  value(standard_output)=value(terminal_output);
  cstack=cstackbottom;
  value(err_end_of_file)=err_end_of_file;
  for(;;)
    funcall(value(toplevel_v),0,lstack);
}

initsig()
{
#ifdef SPARC
  int sigemt(),sigbus(),sigsegv(),sigfpe_ovf(),sigfpe_div();
#endif
  int sigint();


#ifdef SPARC
  signal(SIGBUS,sigbus);
  signal(SIGEMT,sigemt);
  signal(SIGSEGV,sigsegv);
  ieee_handler("set","divisidon",sigfpe_div);
  ieee_handler("set","overflow",sigfpe_ovf);
#endif
  signal(SIGINT,sigint);
}

struct var {
  WORD *addr;
  char *name;
} vars[]={
  &lambda,"lambda",&macro,"macro",&true,"t",
  &system_lib_path,"system_lib_path",
  &lower_case,"lower-case",&upper_case,"upper-case",&openfiles,"openfiles",
  &standard_input,"standard-input",&standard_output,"standard-output",
  &terminal_input,"terminal-input",&terminal_output,"terminal-output",
  &prompt,"prompt",&digits,"digits",&printlevel,"printlevel",
  &printlength,"printlength",
  &default_obvector,"default-obvector",&intern_v,"intern",
  &readtable,"readtable",&macrotable,"macrotable",
  &default_readtable,"default-readtable",
  &default_macrotable,"default-macrotable",
  &unbound_variable,"*UnBoundVariable*",
  &version,"version",&appendopen,"appendopen",
  &inopen,"inopen",&outopen,"outopen",&question,"?",&qqq,"???",
  &usebq,"usebq",&attention_handler,"attention-handler"};

init_var()
{
  int i;
  WORD alstring(),alnstring(),*fp=lstack;
  char buf[256];

  for(i=0;i<sizeof(vars)/sizeof(struct var);i++){
    *vars[i].addr=intern(vars[i].name,strlen(vars[i].name),fp);
  }
  value(prompt)=(topprompt=alstring("> ",fp));
  breakprompt=alstring("@ ",fp);
  value(system_lib_path)=alstring(LIBPATH,fp);
  value(version)=alstring(VERSION,fp);
  value(digits)=itofix(7);
  value(printlevel)=itofix(4);
  value(printlength)=itofix(10);
  value(default_obvector)=value(obvector);
  value(true)=true;
  value(intern_v)=intern_v;
  for(i=0;i<256;i++)buf[i]=i;
  for(i='a';i<='z';i++)buf[i]=i+('A'-'a');
  value(upper_case)=alnstring(buf,256,fp);
  for(i=0;i<256;i++)buf[i]=i;
  for(i='A';i<='Z';i++)buf[i]=i+('a'-'A');
  value(upper_case)=alnstring(buf,256,fp);
}

WORD backtrace_f();
/* gc.c */
WORD gc_f(),gccount_f(),gctime_f(),heapsize_f(),heapfree_f(),symsize_f();
WORD symfree_f(),fixsize_f(),fixfree_f(),stacksize_f(),stack_used_f();
WORD stack_bottom_f(),stack_top_f(),stack_base_f();
WORD othersize_f(),otherfree_f();
/* sysfncd.c */
WORD getd_f(),putd_f(),make_undefined_f(),definedp_f(),specialp_f();
WORD funcname_f(),codesize_f(),maxarg_f(),minarg_f(),program_link_f();
WORD code_load_f();
/* sysfnerr.c */
WORD oldvalue_f();
/* sysfneval.c */
WORD eval_f(),apply_f(),funcall_f();
/* sysfnfix.c */
WORD fxzerop(),fxplusp(),fxminp(),numeq(),sharp(),gt(),ge(),lt(),le(),sub();
WORD add(),mult(),div(),mod(),a1(),s1(),logor(),logand(),logxor(),logshift();
WORD exptfix();
/* sysfnflo.c */
WORD flzerop_f(),flplusp_f(),flminsp_f(),floeq_f(),floshrp_f(),subflo_f();
WORD addflo_f(),mulflo_f(),divflo_f(),modflo_f(),a1flo_f(),s1flo_f();
WORD fix_f(),float_f(),grflo_f(),geflo_f(),ltflo_f(),leflo_f();
/* sysfnhash.c */
WORD hash_f();
/* sysfnio.c */
WORD read_f(),readquote_f(),prin1_f(),print_f(),princ_f(),terpri_f();
WORD flush_f(),cursor_f(),colleft_f(),tab_f(),linelength_f(),intern_f();
WORD intern_soft_f(),tyi_f(),tyipeek_f(),readch_f(),tyo_f(),stream_f();
WORD inopen_f(),outopen_f(),close_f(),stream_mode_f(),appendopen_f();
WORD readmacro_f(),readline_f(),current_line_f(),skipline_f();
WORD single_character_f(),atomlength_f(),alloc_f();
WORD string_stream_f(),string_stream_index_f(),string_stream_limit_f();
/* sysfnlist.c */
WORD cr_f(),fifth_f(),sixth_f(),seventh_f();
WORD caar_f(),cadr_f(),cdar_f(),cddr_f();
WORD caaar_f(),caadr_f(),cadar_f(),caddr_f();
WORD cdaar_f(),cdadr_f(),cddar_f(),cdddr_f();
WORD caaaar_f(),caaadr_f(),caadar_f(),caaddr_f();
WORD cadaar_f(),cadadr_f(),caddar_f(),cadddr_f();
WORD cdaaar_f(),cdaadr_f(),cdadar_f(),cdaddr_f();
WORD cddaar_f(),cddadr_f(),cdddar_f(),cddddr_f();
WORD car_f(),cdr_f(),cons_f(),ncons_f(),xcons_f(),copy_f(),last_f();
WORD length_f(),nth_f(),nthcdr_f(),list_f(),append_f(),reverse_f(),nconc_f();
WORD nreverse_f(),rplaca_f(),rplacd_f(),subst_f(),memq_f(),member_f();
WORD mem_f(),delq_f(),remq_f(),every_f(),some_f(),assq_f(),assoc_f(),ass_f();
/* sysfnmap.c */
WORD map_f(),mapc_f(),maplist_f(),mapcar_f(),mapv_f(),mapvector_f();
/* sysfnmis.c */
WORD quit_f(),abend_f(),toplevel_f(),break_f(),time_f(),address_f(),peek_f();
WORD utilisp_f(),unbreak_f();
/* sysfnnum.c */
WORD zerop_f(),plusp_f(),minusp_f(),oddp_f(),plus_f(),difference_f();
WORD times_f(),quotient_f(),remainder_f(),add1_f(),sub1_f(),abs_f();
WORD minus_f(),sin_f(),cos_f(),tan_f(),arcsin_f(),arccos_f(),arctan_f();
WORD sqrt_f(),log_f(),log10_f(),exp_f(),expt_f(),exptflo_f(),greaterp_f();
WORD lessp_f(),max_f(),min_f();
/* sysfnpred.c */
WORD atom_f(),numberp_f(),stringp_f(),vectorp_f(),referencep_f();
WORD symbolp_f(),consp_f(),codep_f(),predef_f(),eq_f(),neq_f(),streamp_f();
WORD equal_f(),null_f(),fixp_f(),floatp_f(),integerp_f(),bigp_f();
WORD string_streamp_f(),predefinedp_f();
/* sysfnspec.c */
WORD and_e(),or_e(),cond_e(),selectq_e(),prog_e(),catch_e(),go_e(),quote_e();
WORD comment_e(),progn_e(),prog1_e(),prog2_e(),push_e(),pop_e(),setq_e();
WORD loop_e(),match_e(),let_e(),lets_e(),exit_f(),return_f(),throw_f();
/* sysfnstg.c */
WORD character_f(),string_f(),string_length_f(),string_lessp_f(),substring_f();
WORD string_append_f(),string_reverse_f();
WORD string_nreverse_f(),string_search_char_f(),string_search_not_char_f();
WORD string_search_f(),getchar_f(),sref_f(),sset_f(),string_equal_f();
WORD cutout_f(),spread_f(),translate_f(),string_amend_f(),string_amend_or_f();
WORD string_amend_xor_f(),string_amend_and_f(),make_string_f(),bset_f();
WORD bref_f(),string_match_f();
/* sysfnsym.c */
WORD set_f(),make_unbound_f(),boundp_f(),get_f(),putprop_f(),remprop_f();
WORD plist_f(),setplist_f(),pname_f(),symbol_f(),symbol_copy_f(),gensym_f();
WORD call_f(),cd_f(),getenv_f(),argv_f(),localtime_f(),getpid_f();
/* sysfnvec.c */
WORD vref_f(),vset_f(),vector_f(),veclen_f(),reference_f(),deref_f();
WORD setref_f(),referred_vector_f(),referred_index_f(),fill_vector_f();

struct subr{
  char *fcname;
  FP cdtop;
  int minag,maxag;
} subrs[]={
  "backtrace",backtrace_f,0,1,
/* gc.c */
  "gc",gc_f,0,0,"gccount",gccount_f,0,0,"gctime",gctime_f,0,0,
  "heapsize",heapsize_f,0,0,
  "heapfree",heapfree_f,0,0,"symsize",symsize_f,0,0,"symfree",symfree_f,0,0,
  "fixsize",fixsize_f,0,0,"fixfree",fixfree_f,0,0,"stacksize",stacksize_f,0,0,
  "stack-used",stack_used_f,0,0,"stack-bottom",stack_bottom_f,0,0,
  "stack-top",stack_top_f,0,0,"stack-base",stack_base_f,0,0,
  "othersize",othersize_f,0,0,"otherfree",otherfree_f,0,0,
/* sysfncd.c */
  "getd",getd_f,1,1,"putd",putd_f,2,2,"make-undefined",make_undefined_f,1,1,
  "definedp",definedp_f,1,1,"code-load",code_load_f,1,-1,
  "specialp",specialp_f,1,1,"funcname",funcname_f,1,1,
  "codesize",codesize_f,1,1,"program-link",program_link_f,1,1,
  "maxarg",maxarg_f,1,1,"minarg",minarg_f,1,1,
/* sysfneval.c */
  "eval",eval_f,1,1,"apply",apply_f,2,2,"funcall",funcall_f,1,-1,
/* sysfnerr.c */
  "oldvalue",oldvalue_f,0,1,
/* sysfnfix.c */
  "0=",fxzerop,1,1,"0<",fxplusp,1,1,"0>",fxminp,1,1,"=",numeq,2,2,
  "#",sharp,2,2,"<>",sharp,2,2,
  ">",gt,1,-1,">=",ge,1,-1,"<",lt,1,-1,"<=",le,1,-1,"-",sub,1,-1,
  "+",add,0,-1,"*",mult,0,-1,"/",div,1,-1,"\\",mod,2,2,
  "1+",a1,1,1,"1-",s1,1,1,"logor",logor,0,-1,"logand",logand,0,-1,
  "logxor",logxor,0,-1,
  "logshift",logshift,2,2,"^",exptfix,2,2,
/* sysfnflo.c */
  "0=$",flzerop_f,1,1,"0<$",flplusp_f,1,1,"0>$",flminsp_f,1,1,"=$",floeq_f,2,2,
  "#$",floshrp_f,2,2,"-$",subflo_f,1,-1,"+$",addflo_f,0,-1,"*$",mulflo_f,0,-1,
  "/$",divflo_f,1,-1,
  "\\$",modflo_f,2,2,"1+$",a1flo_f,1,1,"1-$",s1flo_f,1,1,"fix",fix_f,1,1,
  "float",float_f,1,1,
  ">$",grflo_f,1,-1,">=$",geflo_f,1,-1,"<$",ltflo_f,1,-1,"<=$",leflo_f,1,-1,
/* sysfnhash.c */
  "hash",hash_f,1,1,
/* sysfnio.c */
  "read",read_f,0,1,"prin1",prin1_f,1,2,
  "print",print_f,1,2,"princ",princ_f,1,2,
  "terpri",terpri_f,0,1,"flush",flush_f,0,1,"cursor",cursor_f,0,1,
  "colleft",colleft_f,0,1,
  "tab",tab_f,1,2,"linelength",linelength_f,0,1,"intern",intern_f,1,2,
  "intern-soft",intern_soft_f,1,2,"tyi",tyi_f,0,1,"tyipeek",tyipeek_f,0,1,
  "readch",readch_f,0,1,"tyo",tyo_f,1,2,"stream",stream_f,1,1,
  "inopen",inopen_f,1,1,"appendopen",appendopen_f,1,1,
  "outopen",outopen_f,1,1,"close",close_f,1,1,"stream-mode",stream_mode_f,1,1,
  "alloc",alloc_f,1,1,"readmacro",readmacro_f,2,4,"readline",readline_f,0,1,
  "current-line",current_line_f,0,1,"skipline",skipline_f,0,1,
  "single-character",single_character_f,1,2,"atomlength",atomlength_f,1,1,
  "string-stream",string_stream_f,1,1,
  "string-stream-index",string_stream_index_f,1,1,
  "string-stream-limit",string_stream_limit_f,1,1,
/* sysfnlist.c */
  "cr",cr_f,1,1,"fifth",fifth_f,1,1,"sixth",sixth_f,1,1,
  "seventh",seventh_f,1,1,
  "first",car_f,1,1,"second",cadr_f,1,1,"third",caddr_f,1,1,
  "fourth",cadddr_f,1,1,
  "caar",caar_f,1,1,"cadr",cadr_f,1,1,"cdar",cdar_f,1,1,"cddr",cddr_f,1,1,
  "caaar",caaar_f,1,1,"caadr",caadr_f,1,1,"cadar",cadar_f,1,1,
  "caddr",caddr_f,1,1,
  "cdaar",cdaar_f,1,1,"cdadr",cdadr_f,1,1,"cddar",cddar_f,1,1,
  "cdddr",cdddr_f,1,1,
  "caaaar",caaaar_f,1,1,"caaadr",caaadr_f,1,1,"caadar",caadar_f,1,1,
  "caaddr",caaddr_f,1,1,
  "cadaar",cadaar_f,1,1,"cadadr",cadadr_f,1,1,"caddar",caddar_f,1,1,
  "cadddr",cadddr_f,1,1,
  "cdaaar",cdaaar_f,1,1,"cdaadr",cdaadr_f,1,1,"cdadar",cdadar_f,1,1,
  "cdaddr",cdaddr_f,1,1,
  "cddaar",cddaar_f,1,1,"cddadr",cddadr_f,1,1,"cdddar",cdddar_f,1,1,
  "cddddr",cddddr_f,1,1,
  "car",car_f,1,1,"cdr",cdr_f,1,1,"cons",cons_f,2,2,"ncons",ncons_f,1,1,
  "xcons",xcons_f,2,2,
  "copy",copy_f,1,1,"last",last_f,1,1,"length",length_f,1,1,"nth",nth_f,2,2,
  "nthcdr",nthcdr_f,2,2,"list",list_f,0,-1,"append",append_f,0,-1,
  "reverse",reverse_f,1,1,
  "nconc",nconc_f,0,-1,"nreverse",nreverse_f,1,1,"rplaca",rplaca_f,2,2,
  "rplacd",rplacd_f,2,2,"subst",subst_f,3,3,"memq",memq_f,2,2,
  "member",member_f,2,2,
  "mem",mem_f,2,2,"delq",delq_f,2,3,"remq",remq_f,2,3,"every",every_f,2,2,
  "some",some_f,2,2,
  "assq",assq_f,2,2,"assoc",assoc_f,2,2,"ass",ass_f,3,3,
/* sysfnmap.c */
  "map" ,map_f,2,2,"mapc",mapc_f,2,2,"maplist",maplist_f,2,2,
  "mapcar",mapcar_f,2,2,
  "mapv",mapv_f,2,2,"mapvector",mapvector_f,2,2,
/* sysfnmis.c */
  "quit",quit_f,0,0,"abend",abend_f,0,0,
  "time",time_f,1,1,"address",address_f,1,1,"peek",peek_f,2,2,
  "unbreak",unbreak_f,0,-1,
/* sysfnnum.c */
  "zerop",zerop_f,1,1,"plusp",plusp_f,1,1,"minusp",minusp_f,1,1,
  "oddp",oddp_f,1,1,
  "plus",plus_f,0,-1,"difference",difference_f,1,-1,"times",times_f,0,-1,
  "quotient",quotient_f,1,-1,"remainder",remainder_f,2,2,"add1",add1_f,1,1,
  "sub1",sub1_f,1,1,
  "abs",abs_f,1,1,"minus",minus_f,1,1,"sin",sin_f,1,1,"cos",cos_f,1,1,
  "tan",tan_f,1,1,
  "arcsin",arcsin_f,1,1,"arccos",arccos_f,1,1,"arctan",arctan_f,1,1,
  "sqrt",sqrt_f,1,1,
  "log",log_f,1,1,"log10",log10_f,1,1,"exp",exp_f,1,1,"expt",expt_f,2,2,
  "^$",exptflo_f,2,2,
  "greaterp",greaterp_f,0,-1,"lessp",lessp_f,0,-1,"max",max_f,1,-1,
  "min",min_f,1,-1,
/* sysfnpred.c */
  "atom",atom_f,1,1,"numberp",numberp_f,1,1,"stringp",stringp_f,1,1,
  "vectorp",vectorp_f,1,1,"referencep",referencep_f,1,1,
  "symbolp",symbolp_f,1,1,"predefinedp",predefinedp_f,1,1,
  "listp",consp_f,1,1,"streamp",streamp_f,1,1,
  "consp",consp_f,1,1,"codep",codep_f,1,1,"predef",predef_f,1,1,"eq",eq_f,2,2,
  "neq",neq_f,2,2,"equal",equal_f,2,2,"null",null_f,1,1,"not",null_f,1,1,
  "fixp",fixp_f,1,1,"string-streamp",string_streamp_f,1,1,
  "floatp",floatp_f,1,1,"integerp",integerp_f,1,1,"bigp",bigp_f,1,1,
/* sysfnspec.c */
  "return",return_f,0,-1,"throw",throw_f,1,-1,"exit",exit_f,0,-1,
/* sysfnstg.c */
  "character",character_f,1,1,"string",string_f,1,1,
  "string-length",string_length_f,1,1,
  "string-lessp",string_lessp_f,2,2,"substring",substring_f,1,3,
  "string-append",string_append_f,0,-1,"string-reverse",string_reverse_f,1,1,
  "string-nreverse",string_nreverse_f,1,1,
  "string-search-char",string_search_char_f,2,3,
  "string-search-not-char",string_search_not_char_f,2,3,
  "string-search",string_search_f,2,3,"getchar",getchar_f,2,2,
  "sref",sref_f,2,2,
  "sset",sset_f,3,3,"string-equal",string_equal_f,2,2,"cutout",cutout_f,3,3,
  "spread",spread_f,2,2,"translate",translate_f,2,2,
  "string-amend",string_amend_f,2,3,
  "string-amend-or",string_amend_or_f,2,3,
  "string-amend-xor",string_amend_xor_f,2,3,
  "string-amend-and",string_amend_and_f,2,3,"make-string",make_string_f,1,2,
  "bset",bset_f,3,3,"bref",bref_f,2,2,"string-match",string_match_f,2,2,
/* sysfnsym.c */
  "set",set_f,2,2,"make-unbound",make_unbound_f,1,1,"boundp",boundp_f,1,1,
  "get",get_f,1,1,
  "putprop",putprop_f,3,3,"remprop",remprop_f,2,2,"plist",plist_f,1,1,
  "setplist",setplist_f,2,2,"pname",pname_f,1,1,"symbol",symbol_f,1,1,
  "symbol-copy",symbol_copy_f,1,1,"gensym",gensym_f,0,2,
/* sysfnsys.c */
  "systemcall",call_f,1,1,"systemchdir",cd_f,1,1,"systemgetenv",getenv_f,1,1,
  "argv",argv_f,0,0,"getpid",getpid_f,0,0,
  "localtime",localtime_f,0,0,
/* sysfnvec.c */
  "vref",vref_f,2,2,"vset",vset_f,3,3,"vector",vector_f,1,2,
  "vector-length",veclen_f,1,1,
  "reference",reference_f,2,2,"deref",deref_f,1,1,"setref",setref_f,2,2,
  "referred-vector",referred_vector_f,1,1,
  "referred-index",referred_index_f,1,1,
  "fill-vector",fill_vector_f,2,2,
};
struct specdef{
  char *fcname;
  FP cdtop;
} specs[]={
  "and",and_e,"or",or_e,"cond",cond_e,"selectq",selectq_e,
  "prog",prog_e,"catch",catch_e,"function",quote_e,
  "go",go_e,"quote",quote_e,"comment",comment_e,"progn",progn_e,
  "prog1",prog1_e,"prog2",prog2_e,"push",push_e,"pop",pop_e,"setq",setq_e,
  "loop",loop_e,"match",match_e,"let",let_e,"lets",lets_e
};
	


init_subr()
{
  int i;
  WORD ptr,aptr,alcode(),*fp=lstack;

  for(i=0;i<sizeof(subrs)/sizeof(struct subr);i++){
    ptr=alcode(0,fp);
    codetop(ptr)=subrs[i].cdtop;
    aptr=intern(subrs[i].fcname,strlen(subrs[i].fcname),fp);
    funcname(ptr)= aptr;
    minarg(ptr)=itofix(subrs[i].minag);
    maxarg(ptr)=itofix(subrs[i].maxag);
    definition(aptr)=ptr;
  }
  quote=intern("quote",5,fp);
}
WORD err_argument_type_f(),err_buffer_overflow_f(),err_catch_f();
WORD err_end_of_file_f(),err_floating_overflow_f(),err_function_f();
WORD err_go_f(),err_index_f(),err_io_f(),err_number_of_arguments_f();
WORD err_open_close_f(),err_read_f(),err_return_f(),err_unbound_variable_f();
WORD err_undefined_function_f(),err_variable_f(),err_zero_division_f();
struct deffunc{
  WORD *var;
  char *fcname;
  FP cdtop;
  int minag,maxag;
} deffuncs[]={
  &toplevel_v,"toplevel",toplevel_f,0,0,
  &utilisp_v,"utilisp",utilisp_f,0,0,
  &break_v,"break",break_f,0,0,
  &err_argument_type,"err:argument-type",err_argument_type_f,1,2,
  &err_buffer_overflow,"err:buffer-overflow",err_buffer_overflow_f,1,2,
  &err_catch,"err:catch",err_catch_f,1,2,
  &err_end_of_file,"err:end-of-file",err_end_of_file_f,1,2,
  &err_floating_overflow,"err:floating-overflow",err_floating_overflow_f,1,2,
  &err_function,"err:function",err_function_f,1,2,
  &err_go,"err:go",err_go_f,1,2,
  &err_index,"err:index",err_index_f,1,2,
  &err_io,"err:io",err_io_f,1,2,
  &err_number_of_arguments,"err:number-of-arguments",err_number_of_arguments_f,1,2,
  &err_open_close,"err:open-close",err_open_close_f,1,2,
  &err_read,"err:read",err_read_f,1,2,
  &err_return,"err:return",err_return_f,1,2,
  &err_unbound_variable,"err:unbound-variable",err_unbound_variable_f,1,2,
  &err_undefined_function,"err:undefined-function",err_undefined_function_f,1,2,
  &err_variable,"err:variable",err_variable_f,1,2,
  &err_zero_division,"err:zero-division",err_zero_division_f,1,2,
  &readquote,"readquote",readquote_f,0,0
};

init_deffunc()
{
  int i;
  WORD ptr,aptr,alcode(),intern(),*fp;

  for(i=0;i<sizeof(deffuncs)/sizeof(struct deffunc);i++){
    ptr=alcode(0,fp);
    codetop(ptr)=deffuncs[i].cdtop;
    *(deffuncs[i].var)=aptr=intern(deffuncs[i].fcname,strlen(deffuncs[i].fcname),lstack);
    funcname(ptr)=aptr;
    minarg(ptr)=itofix(deffuncs[i].minag);
    maxarg(ptr)=itofix(deffuncs[i].maxag);
    definition(aptr)=ptr;
    value(aptr)=aptr;
  }
  value(attention_handler)=break_v;
  value(toplevel_v)=utilisp_v;
}

init_spec()
{
  int i;
  WORD ptr,aptr,alspec(),*fp;

  for(i=0;i<sizeof(specs)/sizeof(struct specdef);i++){
    ptr=alspec(fp);
    spectop(ptr)=specs[i].cdtop;
    aptr=intern(specs[i].fcname,strlen(specs[i].fcname),lstack);
    funcname(ptr)=aptr;
    definition(aptr)=ptr;
  }
}
