/* %W% %D% */

#include <stdio.h> /* for debugging */
#include "constdef.h"
#include "defvar.h"
#include "read.h"

int slash=0;
extern unsigned char strbuf[];
/* $@%9%H%j!<%`$KJ8;z$r0lJ8;z=PNO$9$k(J */

PUTC(c,stream)
WORD stream;
{
  *(buftop(stream)+curpos(stream)++)=c;
  if(c=='\n'){
    FLUSH(stream);
    recend(stream)=curpos(stream)=0;
  }
  if(curpos(stream)>=BUFSIZE){
    FLUSH(stream);
    recend(stream)=curpos(stream)=0;
  }
  return;
}

/* $@=PNO%9%H%j!<%`$N%P%C%U%!>e$N%G!<%?$r<B:]$K=PNO$9$k(J */

FLUSH(stream)
WORD stream;
{
  int len;

  if(mode(stream)&STRINGSTREAM){
    if(fildes(stream)+(len=curpos(stream)-recend(stream))>fixtoi(osize(filname(stream))))
      ioerr(stream,lstack);
    bcopy(buftop(stream)+recend(stream),stringcodes(filname(stream))+fildes(stream),len);
#ifdef notdef
    *(stringcodes(filname(stream))+fildes(stream)+len)=0;
#endif
    fildes(stream)+=len;
  }
  else
    write(fildes(stream),buftop(stream)+recend(stream),curpos(stream)-recend(stream));
  recend(stream)=curpos(stream);
}

/* C$@$NJ8;zNs$r%9%H%j!<%`$K=PNO$9$k(J */

PUTS(str,stream)
char *str;
WORD stream;
{
  while(*str)
    PUTC(*str++,stream);
}

/* $@I8=`=PNO%9%H%j!<%`$K%j%9%W%*%V%8%'%/%H$NI=<(7A$r=PNO$9$k(J */
/* flag$@$r#00J30$NCM$K$9$k$H%9%i%C%7%e$r9T$J$C$?7A$G=PNO$9$k(J */

WORD print_l(ll,flag,fp)
WORD ll,*fp;
int flag;
{
  WORD stream,rtable,str;
  int i;

  checkvec(rtable,value(readtable));
  if(osize(rtable)!=itofix(256))nosymerr(rtable);
  checkstream(stream,value(standard_output));
  if(!(mode(stream)&OUTOPEN))ioerr(stream,fp);
  switch(tag(ll)){
  case FIXNUM: /* fixnum$@$NI=<((J */
    sprintf(strbuf,"%d",fixtoi(ll));
    PUTS(strbuf,stream);
    return(ll);
  case SYMBOL: /* $@%7%s%\%k$rI=<($9$k(J */
    str=prname(ll);
    if(flag && ((int)vecelm(rtable,*(stringcodes(str)))&SLASHTOPBIT))
      PUTC('/',stream);
    PUTC(*(stringcodes(str)),stream);
    for(i=1;i<fixtoi(osize(str));i++){
      if(flag && ((int)vecelm(rtable,*(stringcodes(str)+i))&SLASHBIT))
	PUTC('/',stream);
      PUTC(*(stringcodes(str)+i),stream);
    }
    return(ll);
  case CONS:
    prcons(ll,flag,1,1,fp);
    return(ll);
  case OTHERS:
    switch(otag(ll)){
    case FLONUM:
      prflonum(stream,ll,flag);
      return(ll);
    case BIGNUM:
      prbignum(ll,flag,fp);
      return(ll);
    case VECTOR:
      sprintf(strbuf,"V#%d",ll);
      PUTS(strbuf,stream);
      return(ll);
    case STRING:
      prstring(stream,rtable,ll,flag);
      return(ll);
    case STREAM:
      PUTS("S#",stream);
      prstring(stream,rtable,filname(ll),1);
      break;
    case CODE:
      PUTS("C#",stream);
      PUTS(stringcodes(prname(funcname(ll))),stream);
      break;
    default:
      sprintf(strbuf,"R#%d",ll);
      PUTS(strbuf,stream);
      break;
    }
  }	
  return(ll);
}

/* $@IbF0>.?tE@$r=PNO$9$k(J */

prflonum(stream,ll,flag)
WORD stream,ll;
{
  int dig,expt;
  WORD a;
  double fval;
  char buf[256];

  dig=fixtoi(checkfix(a,value(digits)));
  fval=floval(ll);
  if(fval>=0.0)PUTC('+',stream);
  else{PUTC('-',stream);fval= -fval;}
  if(fval==0.0)expt=0;
  else if(fval>=1.0)
    for(expt=0;fval>=1.0;expt++)fval/=10.0;
  else{
    for(expt=0;fval<1.0;expt--)fval*=10.0;
    expt++;fval/=10.0;
  }
  sprintf(buf,"%%%d.%df^",dig+2,dig);
  sprintf(strbuf,buf,fval);
  PUTS(strbuf,stream);
  if(expt>=0)PUTC('+',stream);
  else {PUTC('-',stream);expt= -expt;}
  sprintf(strbuf,"%02d",expt);
  PUTS(strbuf,stream);
}

/* bignum$@$r=PNO$9$k(J */

#ifdef DEC4
prbignum(ll,flag)
WORD ll;
{
  int size;

  size=fixtoi(osize(ll));
  if(bigcodes(ll,0)&SIGNMASK)
    PUTC('-',value(standard_output));
  prdec(bigcodes(ll,--size),1);
  while(--size>=0)
    prdec(bigcodes(ll,size),0);
}

/* val$@$r#97e$N#1#0?J?t$GI=<($9$k(J */

prdec(val,flag)
{
  static char buf[10]={0,0,0,0,0,0,0,0,0,0};
  char *cptr;
  int i;

  val&=~SIGNMASK;
#ifdef DEC9
  for(i=0;i<9;i++){
    buf[8-i]='0'+(val%10);
#else
  for(i=0;i<4;i++){
    buf[3-i]='0'+(val%10);
#endif
    val/=10;
  }
  if(flag)
    for(cptr=buf;*cptr=='0';cptr++);
  else cptr=buf;
  PUTS(cptr,value(standard_output));
}
#else
prbignum(ll,flag,fp)
WORD ll,*fp;
{
  int size,dec10=10,i,len,j;
  WORD negbig2(),copybig(),new,albignum(),extzbig();
  unsigned char buf[10];

  size=fixtoi(osize(ll));
  if((int)bigcodes(ll,size-1)<0){
    PUTC('-',value(standard_output));
    l(0)=negbig2(ll,fp);
  }
  else
    l(0)=copybig(ll,fp);
  if(size==1){
    sprintf(buf,"%u",*(unsigned int *)(l(0)+BIGCODES));
    for(j=0;buf[j];j++)PUTC(buf[j],value(standard_output));
    return;
  }
  l(0)=extzbig(l(0),size,size+1,fp-1);
  new=albignum(size*6/5,fp-1);
  len=mconv(l(0)+BIGCODES,size*4,new+BIGCODES);
  sprintf(buf,"%u",*(unsigned int *)(new+BIGCODES+len-4));
  for(j=0;buf[j];j++)PUTC(buf[j],value(standard_output));
  for(i=len-4;i>0;i-=4){
    sprintf(buf,"%09u",*(unsigned int *)(new+BIGCODES+i-4));
    for(j=0;j<9;j++)PUTC(buf[j],value(standard_output));
  }
}
#endif
    
/* $@%3%s%9%;%k$rI=<($9$k(J */

prcons(ll,flag,level,length,fp)
WORD ll,*fp;
{
  if(level>=fixtoi(value(printlevel)) && value(printlevel)!=itofix(0)){
    print_l(question,0,fp);
    return;
  }
  PUTC('(',value(standard_output));
  prrest(ll,flag,level,length,fp);
}

prrest(ll,flag,level,length,fp)
WORD ll,*fp;
{
  if(length>=fixtoi(value(printlength)) && value(printlength)!=itofix(0)){
    print_l(qqq,0,fp);
    PUTC(')',value(standard_output));
    return;
  }
  if(tag(car(ll))!=CONS)
    print_l(car(ll),flag,fp);
  else prcons(car(ll),flag,level+1,1,fp);
  if(tag(cdr(ll))==CONS){
    PUTC(' ',value(standard_output));
    prrest(cdr(ll),flag,level,length+1,fp);
  }
  else if(cdr(ll)==nil)PUTC(')',value(standard_output));
  else{
    PUTS(" . ",value(standard_output));
    print_l(cdr(ll),flag,fp);
    PUTC(')',value(standard_output));
  }
}

/* $@%9%H%j%s%0$rI=<($9$k(J */

prstring(stream,rtable,ll,flag)
WORD stream,rtable,ll;
{
  int i,size;

  if(flag)PUTC('\"',stream);
  size=fixtoi(osize(ll));
  for(i=0;i<size;i++){
    if(flag&&((int)vecelm(rtable,*(stringcodes(ll)+i))&STRQBIT))
      PUTC('\"',stream);
    PUTC(*(stringcodes(ll)+i),stream);
  }
  if(flag)PUTC('\"',stream);
}
