; structure of package
; vref 0 : *package* ( symbol )
; vref 1 : package name ( string )
; vref 2 : obvecter of internal symbol ( vector )
; vref 3 : obvecter of external symbol ( vector )
; vref 4 : nicknames ( list of strings )
; vref 5 : use ( list of packages )
; vref 6 : used-by ( list of packages )
(defun make-package (name (nicknames)(use))
  (let ((v (vector 8))
	(iov (vector 128))
	(eov (vector 128))
	(used-by nil)
	(shadow nil)
	)
    (push v package-list)
    (vset v 0 '*package*)
    (vset v 1 name)
    (vset v 2 iov)
    (vset v 3 eov)
    (vset v 4 nicknames)
    (vset v 5 use)
    (vset v 6 used-by)
    (vset v 7 shadow)
    v
    ))
(defun package-name (package)
  (vref package 1))
(defun package-nicknames (package)
  (vref package 4))
(defun rename-package (package newname (new-nicknames))
  (vset package 1 newname)
  (vset package 4 new-nicknames))
(defun get-iov (package)
  (vref package 2))
(defun set-iov (package vector)
  (vset package 2 vector))
(defun get-eov (package)
  (vref package 3))
(defun set-eov (package vector)
  (vset package 3 vector))
(setq package-list nil)
(setq utipackage (make-package "utilisp"))
(setq keypackage (make-package "keyword"))
(set-obvector utipackage obvector)
(setq *package* utipackage)
(defun pintern (name package)
  (lets ((hval (\ (hash name) 128))
	 (or (reference (get-obvector package) hval))
	 (a(mem '(lambda (x y)(string-equal (pname y)x)) name (deref or))))
	(cond ((find-symbol name package))
	      (t (setq sym (symbol name))
		 (putprop sym package '*package*)
		 (putprop sym nil '*export*)
		 (setref or `(,sym))
		 sym))))
(defun find-package (name)
  (car (mem '(lambda (x y) (string-equal name (vref y 1))) name package-list)))
(defun find-internal (name package)
  (lets ((hval (\ (hash name) 128))
	 (or (reference (get-obvector package) hval))
	 (a(mem '(lambda (x y)(string-equal (pname y)x)) name (deref or))))
	(cond (a (car a)))))
(defun find-external (name package)
  (lets ((hval (\ (hash name) 128))
	 (or (reference (get-obvector package) hval))
	 (a(mem '(lambda (x y)(string-equal (pname y)x)) name (deref or))))
	(cond (a (car a)))))
(defun find-symbol (name (package *package* ))
  (prog ((ret (find-internal name package)))
	(cond (ret(return ret))
	      (t (do ((l (vref package 4)(cdr l)))
		     ((atom l)(print ret)(return nil))
		     (setq ret (find-internal name (car l)))
	(print ret)
		     (cond (ret (return ret))))))))
(defun use-package (package-to-use (package *package))
  (cond ((member package-to-use (vref package 5))t)
	(t (vset package 5 `(package-to-use (vref package 5))) t)))
(defun new-intern (name)
  (let ((i (string-search-char ":" name)))
    (cond ((null i)(pintern name *package*))
	  ((equal i 0)(pintern (substring name 1) cp keypackage))
	  (t (pintern (substring name (1+ i))
		      (find-package (substring name 0 i)))))))
(setq intern 'new-intern)
(make-package "common")
