/* %W% %D% */

#include "constdef.h"
#include "defvar.h"

WORD fxzerop(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  if(tsub(ag(0),0)==0)return(true);
  else return(nil);
}

WORD fxplusp(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  if(tsub(ag(0),0)>0)return(true);
  else return(nil);
}

WORD fxminp(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  if(tsub(ag(0),0)<0)return(true);
  else return(nil);
}

WORD numeq(na,fp)
WORD *fp;
{
  WORD a1;

  if(na!=2)parerr();
  if(tsub(ag(0),ag(1))==0)return(true);
  else return(nil);
}

WORD sharp(na,fp)
WORD *fp;
{
  WORD a1;

  if(na!=2)parerr();
  if(tsub(ag(0),ag(1))!=0)return(true);
  else return(nil);
}

WORD gt(na,fp)
WORD *fp;
{
  WORD a1,a2;
  int flag=0;

  if(na==0)return(true);
  a2= pop();
  while(--na>0){
	a1=pop();
    if(tsub(a1,a2)>0)a2=a1;
    else {
      return(nil);
    }
  }
  return(true);
}

WORD ge(na,fp)
WORD *fp;
{
  WORD a1,a2;

  if(na==0)return(true);
  a2=pop();
  while(--na>0){
	a1=pop();
    if(tsub(a1,a2)>=0)a2=a1;
    else
      return(nil);
  }
  return(true);
}

WORD lt(na,fp)
WORD *fp;
{
  WORD a1,a2;

  if(na==0)return(true);
  a2=pop();
  while(--na>0){
	a1=pop();
    if(tsub(a1,a2)<0)a2=a1;
    else
      return(nil);
  }
  return(true);
}

WORD le(na,fp)
WORD *fp;
{
  WORD a1,a2;

  if(na==0)return(true);
  a2=pop();
  while(--na>0){
	a1=pop();
    if(tsub(a1,a2)<=0)a2=a1;
    else
      return(nil);
  }
  return(true);
}

WORD sub(na,fp)
WORD *fp;
{
  int rval;
  WORD a1;

  if(na==0)parerr();
  rval=(int)pop();
  if(na==1)return((WORD)tsub(0,rval));
  while(--na>1){
	a1=pop();
    rval=tadd(a1,rval);
  }
  a1=pop();
  return((WORD)tsub(a1,rval));
}

WORD add(na,fp)
WORD *fp;
{
  int rval;
  WORD a1;

  rval=0;
  while(na-->0){
    a1=pop();
    rval=tadd(rval,a1);
  }
  return((WORD)rval);
}

WORD mult(na,fp)
WORD *fp;
{
  int rval;
  WORD t;

  rval=1;
  while(na-->0){
    if(tag(t=pop())!=FIXNUM)*(int *)t=0;
    rval*=fixtoi(t);
  }
  return(itofix(rval));
}

WORD div(na,fp) /* bugged version of div */
WORD *fp;
{
  int rval;
  WORD t,*tmpstack;

  if(na==0)parerr();
  if(tag(t= *(WORD *)(fp+na-1))!=FIXNUM)*(int *)t=0;
  rval=fixtoi(t);
  while(--na>0){
    if(tag(t=pop())!=FIXNUM)*(int *)t=0;
    if(t==itofix(0))zerodiverr(fp);
    rval/=fixtoi(t);
  }
  return(itofix(rval));
}

WORD mod(na,fp) /* bugged version */
WORD *fp;
{
  WORD t;
  int a,b;

  if(na!=2)parerr();
  if(tag(t= *fp)!=FIXNUM)*(int *)t=0;
  b=fixtoi(t);
  if(b==0)zerodiverr(fp);
  if(tag(t= *(fp+1))!=FIXNUM)*(int *)t=0;
  a=fixtoi(t);
  return(itofix(a%b));
}

WORD a1(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  return((WORD)tadd(ag(0),FIX1));
}

WORD s1(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  return((WORD)tsub(ag(0),FIX1));
}

WORD logor(na,fp)
WORD *fp;
{
  WORD t,rval;

  rval=0;
  while(na-->0){
    if(tag(t=pop())!=FIXNUM)*(int *)t=0;
    rval=(WORD)((int)rval|(int)t);
  }
  return(rval);
}

WORD logand(na,fp)
WORD *fp;
{
  WORD t,rval;

  rval= (WORD)-FIX1;
  while(na-->0){
    if(tag(t=pop())!=FIXNUM)*(int *)t=0;
    rval=(WORD)((int)rval&(int)t);
  }
  return(rval);
}

WORD logxor(na,fp)
WORD *fp;
{
  WORD t,rval;

  rval=(WORD)0;
  while(na-->0){
    if(tag(t=pop())!=FIXNUM)*(int *)t=0;
    rval=(WORD)((int)rval^(int)t);
  }
  return(rval);
}


WORD logshift(na,fp)
WORD *fp;
{
  WORD t;
  int a,b;
  if(na!=2)parerr();
  if(tag(t= *fp)!=FIXNUM)*(int *)t=0;
  b=fixtoi(t);
  if(tag(t= *(fp+1))!=FIXNUM)*(int *)t=0;
  if(b>0)
    return((WORD)((int)t<<b));
  return((WORD)(((int)t>>(-b))&0xfffffff0));
}


WORD exptfix(na,fp)
WORD *fp;
{
  WORD t;
  int a,b,rval=1;

  if(na!=2)parerr();
  if(tag(t= *fp)!=FIXNUM)*(int *)t=0;
  b=fixtoi(t);
  if(tag(t= *(fp+1))!=FIXNUM)*(int *)t=0;
  a=fixtoi(t);
  while(--b>=0)rval*=a;
  return(itofix(rval));
}

